%global _description %{expand:
gsl-lite is an implementation of the C++ Core Guidelines Support Library
originally based on Microsoft GSL.
}

%bcond_without tests

# Header only, so no debuginfo is generated
%global debug_package %{nil}

# Workaround GCC bug:
# Do not error for array bound warnings
# Upstream bug: https://github.com/gsl-lite/gsl-lite/issues/303
# GCC bug: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=100137
%global optflags %(echo "%optflags -Wno-error=array-bounds")

Name:           gsl-lite
Version:        0.38.1
Release:        1%{?dist}
Summary:        Header-only version of ISO C++ Guidelines Support Library (GSL)

License:        MIT
URL:            https://github.com/gsl-lite/gsl-lite
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  gcc-c++

%description %_description

%package        devel
Summary:        Development files for %{name}
Provides:       %{name}%{?_isa} = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -n %{name}-%{version}


%build
%if %{with tests}
%cmake -DGSL_LITE_OPT_BUILD_TESTS=ON -DGSL_LITE_OPT_BUILD_EXAMPLES=ON
%else
%cmake -DGSL_LITE_OPT_BUILD_EXAMPLES=ON
%endif
%cmake_build


%install
%cmake_install

%check
%if %{with tests}
%ctest
%endif

%files devel
%license LICENSE
%doc README.md CHANGES.txt
%{_includedir}/*
%{_libdir}/cmake/%{name}

%changelog
* Thu Apr 22 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.38.1-1
- Update to latest bugfix release

* Mon Apr 19 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.38.0-1
- Include upstream workaround for GCC bug
- Enable tests by default
- Disable tests on s390x

* Sun Apr 18 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.38.0-1
- Initial build
